//+------------------------------------------------------------------+
//|                                               Advanced forecater |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 2

extern string TimeFrame  = "Current time frame";
extern int    FastEma    = 13;
extern int    SlowEma    = 34;
extern int    SignalSMA  = 8;

double temp1[];
double temp2[];
double sum[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0,sum);
   SetIndexBuffer(1,temp1);
   SetIndexBuffer(2,temp2);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
   IndicatorShortName(timeFrameToString(timeFrame)+" Advanced_forecater");
   return (0);
}

//
//
//
//
//

int start() 
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int i,limit = MathMin(Bars-countedBars,Bars-1);
            double Multiply_Factor_1 = 2.0 / (FastEma + 1.0);
            double Multiply_Factor_2 = 2.0 / (SlowEma + 1.0);
            double Multiply_Factor_3 = Multiply_Factor_1 - Multiply_Factor_2;
                  if (MathAbs(Multiply_Factor_3) == 0.0) return(0);
                  if (timeFrame!=Period())
                  {
                     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
                        for(i=limit; i>=0; i--) sum[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEma,SlowEma,SignalSMA,0,iBarShift(NULL,timeFrame,Time[i]));
                        return(0);
                  }

   //
   //
   //
   //
   //
 
   for(i=limit; i>=0; i--) temp1[i] = iMA(NULL,0,FastEma,0,MODE_EMA, PRICE_CLOSE,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) temp2[i] = iMAOnArray(temp1,0,SignalSMA,0,MODE_SMA,i);
   for(i=limit; i>=0; i--)
      sum[i] = (Multiply_Factor_1 * iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)+                  iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) - 
                                    iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)-Multiply_Factor_2*iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) + temp2[i]) / Multiply_Factor_3;
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}